<template>
    <div class="col-12">
        <h2>Gestion des Taches</h2>
        <br>
        <div class="col-12" v-if="canSee">
            <div class="form-group">
                <label>
                    <strong>Développeur</strong>
                </label>
                <select class="form-control" type="text" name="technical" v-model="user" required>
                    <option v-for="technical in users" v-bind:value="technical._id">
                        {{technical.firstname}} {{technical.lastname}}
                    </option>
                </select>
            </div>
        </div>
        <div class="clearfix"></div>
        <fullCalendar v-bind:events="events" locale="fr" v-on:dayClick="dayClick" v-on:eventClick="eventClick"></fullCalendar>
    </div>
</template>

<script>
import fullCalendar from 'vue-fullcalendar'
export default {
    computed: {
        events() {
            let events = new Array();
            let filterId = "none";
            let user = this.$store.getters.getCurrentUser;
            if (user.role === "administrateur" || user.role === "responsable RH" || user.role === "chef de projet") {
                filterId = this.user;
            } else {
                filterId = user._id;
            }
            this.$store.getters.getAllEvents.forEach(function(element) {
                if ((element.user && element.user._id === filterId) || filterId === "none") {
                    element.cssClass = "red";
                    events.push(element);
                }
            });
            return events;
        },
        users() {
            if (this.$store.getters.getAllDevelopers) {
                return this.$store.getters.getAllDevelopers;
            }
            return [];
        },
        canSee() {
            let user = this.$store.getters.getCurrentUser;
            if (user.role === "administrateur" || user.role === "responsable RH" || user.role === "chef de projet") {
                return true;
            }
            return false;
        }
    },
    data() {
        return {
            user: {}
        }
    },
    components: {
        fullCalendar
    },
    created() {
        this.$store.dispatch('setAllEvents');
        this.$store.dispatch('getAllUsers');
    },
    methods: {
        eventClick(event) {
            this.$router.push({
                path: "" + event._id + "/edit",
                append: true
            });
        },
        dayClick(day) {
            this.$router.push({
                path: "new",
                append: true
            });
        }
    }
}
</script>

<style scoped>

</style>
